// -*- mode: C++; tab-width: 4; indent-tabs-mode: nil -*- (for GNU Emacs)
//
// Copyright (c) 1998 Microsoft Corporation
//
// This file is part of the Microsoft Research IPv6 Network Protocol Stack.
// You should have received a copy of the Microsoft End-User License Agreement
// for this software along with this release; see the file "license.txt".
// If not, please see http://www.research.microsoft.com/msripv6/license.htm,
// or write to Microsoft Research, One Microsoft Way, Redmond, WA 98052-6399.
//
// Abstract:
//
// Internet Group Message Protocol for Internet Protocol Version 6.
// See RFC 1885 and RFC 2236 for details.
//


// MLD values defined by the spec 
#define MLD_UNSOLICITED_REPORT_INTERVAL   (ushort)ConvertSecondsToTicks(10)
#define MLD_ROUTER_ALERT_OPTION_TYPE      0
#define MLD_HOP_LIMIT                     1


// MLD message struct - this immediately follows the ICMPv6 header.
typedef struct MLDMessage {
    ushort      MaxResponseDelay;
    ushort      Unused;
    IPv6Addr    GroupAddr;
} MLDMessage;


// Combined structure used for inserting router alert into MLD messages.
typedef struct MLDRouterAlertOption {
    IPv6HopByHopHeader        Header;
    IPv6RouterAlertOption     Option;
    IPv6PadNOption            Pad;
    // no pad data is needed since with the PadN option the sizeof
    // this struct = 8..
} MLDRouterAlertOption;


//
// MLDReportList - contains a temporary list of groups to send 
// membership reports to.
//
typedef struct MLDReportList {
    struct MLDReportList *Next;
    IPv6Addr GroupAddr;            // Multicast group address.
    NetTableEntry *NTE;            // NTE associated with this address.
} MLDReportList;


