// -*- mode: C++; tab-width: 4; indent-tabs-mode: nil -*- (for GNU Emacs)
//
// Copyright (c) 1985-1998 Microsoft Corporation
//
// This file is part of the Microsoft Research IPv6 Network Protocol Stack.
// You should have received a copy of the Microsoft End-User License Agreement
// for this software along with this release; see the file "license.txt".
// If not, please see http://www.research.microsoft.com/msripv6/license.htm,
// or write to Microsoft Research, One Microsoft Way, Redmond, WA 98052-6399.
//


#include <windows.h>
#include <winsock2.h>
#include <ws2ip6.h>

int WSAAPI
inet6_addr(const char *s, struct in6_addr *Address)
{
    struct sockaddr_in6 sin6;
    int addrlen = sizeof sin6;

    sin6.sin6_family = AF_INET6; // shouldn't be required but is

    if ((WSAStringToAddress((char *)s,
                            AF_INET6,
                            NULL,       // LPWSAPROTOCOL_INFO
                            (struct sockaddr *) &sin6,
                            &addrlen)
         == SOCKET_ERROR) ||
        (addrlen != sizeof sin6) ||
        (sin6.sin6_family != AF_INET6))
        return FALSE;

    memcpy(Address, &sin6.sin6_addr, sizeof *Address);
    return TRUE;
}
